<%@ Page Language="C#" AutoEventWireup="true"
	ClassName="ChooseYourStory.Web.UI.Stories.Default" Title="Storygames" %>

<%@ Register Assembly="ChooseYourStory" Namespace="ChooseYourStory.Web.Controls"
	TagPrefix="cys" %>
<%@ Register Src="CategoryBox.ascx" TagPrefix="uc" TagName="CategoryBox" %>
<%@ Import Namespace="ChooseYourStory.Utilities" %>
<%@ Import Namespace="ChooseYourStory.Web.Controls" %>
<%@ Import Namespace="System.Data" %>
<%@ Import Namespace="System.Xml" %>
<%@ Import Namespace="System.Data.SqlClient" %>

<script runat="server" language="C#">
	private XmlNodeList DataReaderToNodeList(SqlDataReader dr)
	{
		XmlDocument doc = new XmlDocument();
		doc.AppendChild(doc.CreateElement("stories"));

		while (dr.Read())
		{
			XmlElement el = doc.CreateElement("story");
			XmlAttribute at = doc.CreateAttribute("title");
			at.Value = (string)dr["Story_Title"];
			el.Attributes.Append(at);
			doc.DocumentElement.AppendChild(el);
		}
		dr.Dispose();

		return doc.SelectNodes("stories/story");
	}

	private bool _alt = false;
	private void AddCategoryList(Control ctrl)
	{
		if (!_alt)
		{
			CategoryList.Controls.Add(new LiteralControl("<div style=\"display: flex; margin: 1rem; justify-content: center;\">"));
			CategoryList.Controls.Add(ctrl);
		}
		else
		{
			CategoryList.Controls.Add(ctrl);
			CategoryList.Controls.Add(new LiteralControl("</div>"));
		}

		_alt = !_alt;
	}

	protected void Page_Load(object sender, EventArgs e)
	{
		Title = "Storygames";

		SqlConnection con = new SqlConnection(ConfigurationManager.ConnectionStrings["ChooseYourStory"].ConnectionString);
		con.Open();

		{ //Featured
			XmlDocument doc = new XmlDocument();
			using (SqlCommand cmd = new SqlCommand())
			{
				cmd.Connection = con;
				cmd.CommandText = "Stories_Get_Featured_Story_Xml";
				cmd.CommandType = CommandType.StoredProcedure;

				XmlReader xr = cmd.ExecuteXmlReader();
				doc.Load(xr);
			}
			foreach (XmlNode cat in doc.SelectNodes("/categories/category"))
			{
                if (cat.InnerXml == "<story />") cat.InnerXml = string.Empty;
                
				CategoryBox box = (CategoryBox)LoadControl("CategoryBox.ascx");
				box.CategoryXmlNode = cat;
				AddCategoryList(box);
			}
		}

		{ //New
			using (SqlCommand cmd = new SqlCommand())
			{
				cmd.Connection = con;
				cmd.CommandText = "Stories_Get_New_Stories";
				cmd.CommandType = CommandType.StoredProcedure;

				CategoryBox box = (CategoryBox)LoadControl("CategoryBox.ascx");
                box.Name = "Newly Created Storygames";
				box.Description = "Fresh from the oven";
				box.ImageUrl = string.Format("~/App_Themes/{0}/images/categories/new.gif", Page.Theme);
				box.MoreStoriesUrl = string.Format("~/stories/new.aspx");
                box.MoreStoriesText = "[See All New Storygames]";
				box.RssFeedUrl = "newStoriesRss.ashx";

				box.SetStoryLinks(DataReaderToNodeList(cmd.ExecuteReader()));
				AddCategoryList(box);
			}
		}

		{ //Top
			using (SqlCommand cmd = new SqlCommand())
			{
				cmd.Connection = con;
				cmd.CommandText = "Stories_Get_Top_Rated_Stories";
				cmd.CommandType = CommandType.StoredProcedure;

				CategoryBox box = (CategoryBox)LoadControl("CategoryBox.ascx");
                box.Attributes.CssStyle.Add(HtmlTextWriterStyle.MarginRight, "1rem");
				box.Name = "Top Rated Storygames";
				box.Description = "Readers say these are the best";
				box.ImageUrl = string.Format("~/App_Themes/{0}/images/categories/top_rated.gif", Page.Theme);
                box.MoreStoriesUrl = string.Format("~/stories/top.aspx");
                box.MoreStoriesText = "[See All Top Storygames]";
                
				box.SetStoryLinks(DataReaderToNodeList(cmd.ExecuteReader()));
				AddCategoryList(box);
			}
		}

		con.Close();


	}
</script>
<asp:Content ContentPlaceHolderID=HeaderContentPlaceHolder runat="server">
<link rel="alternate" type="application/rss+xml" title="New Stories RSS" href="newStoriesRss.ashx" />
</asp:Content> 
<asp:Content ContentPlaceHolderID="MainContentPlaceHolder" runat="Server">
	<div id="mainContent">
		<h1 style="margin-bottom: 0px; text-align: center">
			Storygame Categories
		</h1>
	    <asp:PlaceHolder runat="server" ID="CategoryList" />
	</div>
	<cys:AspPage runat="server" Url="~/Includes/footer.asp" />
</asp:Content>
