﻿<% 
	Option Explicit
	
	CheckHeader "search.aspx"
 %>
<!-- #include file="../Includes/Request_Start.inc.asp" -->
<script runat="server" language="VBScript" src="../Includes/CheckHeader.vbs"></script>
<script runat="server" language="jscript" src="../Includes/urlEncoding.js"></script>
<script runat="server" language="VBScript" src="../Includes/categories.vbs"></script>
<script runat="server" src="../Includes/helperFunctions.vbs" language="vbscript"></script>
<script>
// Parse url parameters
const urlParams = (new URL(document.location)).searchParams;
const urlParamsParsed = {
    categories: [],
    tags: []
};

if (urlParams.has("cats")) {
    urlParamsParsed.categories = urlParams.get("cats").toLowerCase().split(",");
}

if (urlParams.has("tags")) {
    urlParamsParsed.tags = urlParams.get("tags").toLowerCase().split(",");
}

// Set default values
let storyListData = [];
let storyListDataFiltered = [];
const storyListFiltersDefault = {
    inclEveryTag: true,
    inclFeatured: [true, true],
    inclRated: [true, true],
    inclCategories: [],
    inclTags: [],
    minLength: 1,
    maxLength: 8,
    maxRating: 8,
    minRating: 3,
    maxMaturity: 8,
    minMaturity: 1,
};

let storyListPageCount = 0;
let storyListPageIndex = 0;
const storyListPaginationDefault = {
    order: 1,
    pageSize: 20,
    sort: "rating"
};

const storyListCategories = [];
const storyListTags = [];

const url = new URL(document.location);
const query = Object.fromEntries(url.searchParams);

$(document).ready(function() {
  $("#filterCategoryContainer").addClass("loading");
  $("#filterTagContainer").addClass("loading");
  $("#storygameList").addClass("loading");
});

function href(pathname) {
  return new URL(pathname, document.location).toString();
}

function storyListFilter(filters) {
    filters = {
        inclEveryTag: !$("#filterTagAny").prop("checked"),
        inclFeatured: $("#filterFeatureFeatured").prop("checked") ? [true, false] : $("#filterFeatureUnfeatured").prop("checked") ? [false, true] : [true, true],
        inclRated: $("#filterRatedRated").prop("checked") ? [true, false] : $("#filterRatedUnrated").prop("checked") ? [false, true] : [true, true],
        inclCategories: $("#filterCategoryContainer input:checked").map(function() {
            return this.value;
        }).get(),
        inclTags: $("#filterTagContainer input:checked").map(function() {
            return this.value;
        }).get(),
        maxRating: parseInt($("#filterRatingMax").val()) || storyListFiltersDefault.maxRating,
        minRating: parseInt($("#filterRatingMin").val()) || storyListFiltersDefault.minRating,
        maxLength: parseInt($("#filterLengthMax").val()) || storyListFiltersDefault.maxLength,
        minLength: parseInt($("#filterLengthMin").val()) || storyListFiltersDefault.minLength,
        maxMaturity: parseInt($("#filterMaturityMax").val()) || storyListFiltersDefault.maxMaturity,
        minMaturity: parseInt($("#filterMaturityMin").val()) || storyListFiltersDefault.minMaturity,
        maxDate: new Date($("#filterDateMax").val()),
        minDate: new Date($("#filterDateMin").val())
    };

    filters = Object.assign(Object.assign({}, storyListFiltersDefault), filters);

    for (let key in filters) {
        let value = filters[key];
        if (Array.isArray(value)) value = value.join(",");
        if (!value || value === storyListFiltersDefault[key]) url.searchParams.delete(key);
        else url.searchParams.set(key, value);
    }

    return storyListData.filter(a => {
        var pubdate = new Date(a.published);
        return (
            Math.round(a.rating) >= filters.minRating &&
            Math.round(a.rating) <= filters.maxRating &&
            Math.round(a.length) >= filters.minLength &&
            Math.round(a.length) <= filters.maxLength &&
            Math.round(a.maturity) >= filters.minMaturity &&
            Math.round(a.maturity) <= filters.maxMaturity &&
            (filters.inclCategories.length === 0 || filters.inclCategories.some(cat => a.category === cat)) &&
            (filters.inclEveryTag ?
                filters.inclTags.every(tag => a.tags.includes(tag)) :
                filters.inclTags.some(tag => a.tags.includes(tag))
            ) &&
            ((a.myrating && filters.inclRated[0]) || !a.myrating && filters.inclRated[1]) &&
            ((a.featured && filters.inclFeatured[0]) || !a.featured && filters.inclFeatured[1]) &&
            (!isNaN(filters.minDate.valueOf()) ?
                (!isNaN(filters.maxDate.valueOf()) ?
                    (filters.minDate <= pubdate && pubdate <= filters.maxDate) :
                    filters.minDate <= pubdate
                ) : !isNaN(filters.maxDate.valueOf()) ? pubdate <= filters.maxDate : true
            )
        );
    });
}

function storyListPaginate(data = []) {
    pagination = {
        order: $("#paginationSort")
            .val()
            .split("-")[1] === "asc" ?
            1 :
            -1,
        pageSize: parseInt($("#paginationPageSize").val()) ||
            storyListPaginationDefault.pageSize,
        sort: $("#paginationSort")
            .val()
            .split("-")[0]
    };
    pagination = Object.assign(storyListPaginationDefault, pagination);

    if ($("#paginationSearch").val()) data = data.filter(a => {
        var test = $("#paginationSearch").val().toLowerCase();
        return (
            a.title.toLowerCase().includes(test) ||
            a.username.toLowerCase().includes(test)
        );
    });

    data.sort((a, b) => {
        var sortA = a.rating,
            sortB = b.rating;
        (sortC = a.title.replace(/^(the|an?)\W+|[^A-Z0-9]+/gi, "").toUpperCase()),
        (sortD = b.title.replace(/^(the|an?)\W+|[^A-Z0-9]+/gi, "").toUpperCase());
        switch (pagination.sort) {
            case "alpha":
                (sortA = sortC), (sortB = sortD);
                break;
            case "length":
                (sortA = a.length), (sortB = b.length);
                break;
            case "published":
                (sortA = new Date(a.published)), (sortB = new Date(b.published));
                break;
            case "ratings":
                (sortA = a.ratings), (sortB = b.ratings);
                break;
        }
        return (
            (sortA > sortB ? 1 : sortA < sortB ? -1 : 0) * pagination.order ||
            (sortC > sortD ? 1 : sortC < sortD ? -1 : 0)
        );
    });

    storyListPageCount = Math.ceil(data.length / pagination.pageSize);
    if (storyListPageIndex >= storyListPageCount) { storyListPageIndex = (storyListPageCount || 1) - 1; }

    var pageStart = (storyListPageIndex * pagination.pageSize + 1),
        pageEnd = ((storyListPageIndex + 1) * pagination.pageSize);

    $(".paginationNumeration").attr("title", (data.length > 0 ? pageStart : 0) + "–" + (pageEnd < data.length ? pageEnd : data.length) + " of " + data.length);
    $(".paginationNumerator").text(storyListPageIndex + 1);
    $(".paginationDenominator").text(storyListPageCount || 1);

    return data.slice(
        storyListPageIndex * pagination.pageSize,
        (storyListPageIndex + 1) * pagination.pageSize
    );
}

function storyListApply(data = []) {
    $("#storygameList").empty();
    data.forEach(e => {
        $("#storygameList").append(
            $("<div></div>", {
                class: "entry"
            }).append(
                $("<div></div>", {
                    class: "fullwidth"
                }).append(
                    $("<h2></h2>")
                    .append(
                        $("<a></a>", {
                            href: e.url
                        }).text(e.title)
                    )
                    .css("display", "inline-block"),
                    " by ",
                    $("<div></div>")
                    .append(
                        $("<a></a>", {
                            href: "/Member/?Username=" + e.username
                        }).text(e.username)
                    )
                    .css("display", "inline-block")
                ),
                $("<div></div>", {
                    class: "flex"
                }).append(
                    $("<div></div>", {
                        style: "display: flex;"
                    }).append(
                        $("<a></a>", {
                            href: e.url + "/comments",
                            title: e.myrating ? `${e.rating} (you rated this ${e.myrating})` : e.rating || 0
                        }).append(
                            $("<div></div>", {
                                class: "flex ratingContainer"
                            }).append(
                                $("<div></div>", {
                                    class: "rating" + (e.myrating ? " rated" : "")
                                }).css("width", 100 * ((e.myrating || e.rating || 0) / 8) + "%")
                            )
                        ),
                        $("<span></span>", {
                          class: "category"
                        }).append(
                          e.category
                        )
                    ),
                    e.desc ?
                    $("<div></div>", {
                        class: "flex"
                    }).text(e.desc) :
                    $("<div></div>", {
                        class: "flex"
                    }).html("&nbsp;"),
                    $("<div></div>", {
                        class: "flex"
                    }).append(
                        e.featured ? $("<span></span>", {
                            class: "tag featured"
                        }).text(" Featured") : "",
                        e.tags.map(tag => {
                            return $("<span></span>", {
                                class: "tag"
                            }).append(
                                tag
                            )[0];
                        }) ||
                        $("<span></span>", {
                            class: "tag"
                        }).text("(none)")
                    )
                ),
                $("<div></div>", {
                    class: "flex"
                }).append(
                    $("<div></div>", {
                        class: "flex"
                    }).append(
                        $("<strong></strong>").text(e.ratings || "0"),
                        " rating" + (e.ratings === 1 ? "" : "s")
                    ),
                    $("<div></div>", {
                        class: "flex"
                    }).append(
                        $("<strong></strong>").text((e.length || "?") + "/8"),
                        " length"
                    ),
                    $("<div></div>", {
                        class: "flex"
                    }).text(e.published && new Date(e.published) ? new Date(e.published).toDateString() : "date unknown")
                )
            )
        );
    });
    $("#storygameListSubPagination").toggle(storyListPageCount > 1);
}

function storyListProcess(nofilter) {
    if (!nofilter) storyListDataFiltered = storyListFilter();
    var storyListPage = storyListDataFiltered;
    storyListPage = storyListPaginate(storyListPage);
    storyListApply(storyListPage);
}

$("body").on("click", "h2[data-for]", function() {
    var e = $("#" + this.dataset.for);
    if ($(this).hasClass("collapsed")) e.show();
    else e.hide();
    $(this).toggleClass("collapsed");
});

$("body").on("click", "#storygameListFilters #filterFeatureAll", function() {
    storyListProcess();
});
$("body").on("click", "#storygameListFilters #filterFeatureFeatured", function() {
    storyListProcess();
});
$("body").on("click", "#storygameListFilters #filterFeatureUnfeatured", function() {
    storyListProcess();
});

$("body").on("submit", "#storygameListFilters", function(e) {
    storyListProcess();
    return false;
});

$("body").on("change", "#filterCategoryContainer input[type='checkbox']", function() {
    $("[data-for='filterCategoryContainer']").attr("data-value", $("#filterCategoryContainer input:checked").length);
    $("#filterCategoryArray").val($("#filterCategoryContainer input:checked").map(function() {
        return this.value;
    }).get().join(","));
    storyListProcess();
});

$("body").on("change", "#filterTagContainer input[type='checkbox']", function() {
    $("[data-for='filterTagContainer']").attr("data-value", $("#filterTagContainer input:checked").length);
    $("#filterTagArray").val($("#filterTagContainer input:checked").map(function() {
        return this.value;
    }).get().join(","));
    storyListProcess();
});

$("body").on("click", "#storygameListFilters #filterRatedAll", function() {
    storyListProcess();
});
$("body").on("click", "#storygameListFilters #filterRatedRated", function() {
    storyListProcess();
});
$("body").on("click", "#storygameListFilters #filterRatedUnrated", function() {
    storyListProcess();
});

$("body").on("change", "#storygameListFilters #filterRatingMin", function() {
    if ($(this).val() > $("#filterRatingMax").val()) {
        $("#filterRatingMax").val($(this).val());
    }
    storyListProcess();
});

$("body").on("change", "#storygameListFilters #filterRatingMax", function() {
    if ($(this).val() < $("#filterRatingMin").val()) {
        $("#filterRatingMin").val($(this).val());
    }
    storyListProcess();
});

$("body").on("change", "#storygameListFilters #filterLengthMin", function() {
    if ($(this).val() > $("#filterLengthMax").val()) {
        $("#filterLengthMax").val($(this).val());
    }
    storyListProcess();
});

$("body").on("change", "#storygameListFilters #filterLengthMax", function() {
    if ($(this).val() < $("#filterLengthMin").val()) {
        $("#filterLengthMin").val($(this).val());
    }
    storyListProcess();
});

$("body").on("change", "#storygameListFilters #filterMaturityMin", function() {
    if ($(this).val() > $("#filterMaturityMax").val()) {
        $("#filterMaturityMax").val($(this).val());
    }
    storyListProcess();
});

$("body").on("change", "#storygameListFilters #filterMaturityMax", function() {
    if ($(this).val() < $("#filterMaturityMin").val()) {
        $("#filterMaturityMin").val($(this).val());
    }
    storyListProcess();
});

$("body").on("change", "#storygameListFilters #filterDateMin", function() {
    if (new Date($(this).val()) > new Date($("#filterDateMax").val())) {
        $("#filterDateMax").val($(this).val());
    }
    storyListProcess();
});

$("body").on("change", "#storygameListFilters #filterDateMax", function() {
    if (new Date($(this).val()) < new Date($("#filterDateMin").val())) {
        $("#filterDateMin").val($(this).val());
    }
    storyListProcess();
});

$("body").on("submit", "#storygameListPagination", function() {
    storyListProcess(true);
    return false;
});

$("body").on("change", "#storygameListPagination select, #storygameListPagination input[type='text']", function() {
    storyListProcess(true);
});

$("body").on("click", ".storygameListPagination input[type='button']", function() {
    if (this.className === "paginationPrev" && storyListPageIndex > 0) {
      storyListPageIndex--;
      storyListProcess(true);
    } else if (this.className === "paginationNext" && storyListPageIndex < storyListPageCount - 1) {
      storyListPageIndex++;
      storyListProcess(true);
    }
});

$("body").on("click", ".category", function() {
    const inputElement = $("#filterCategoryContainer label input")
        .get().filter((e) => e.value === $(this).text())[0];

    inputElement.checked = !inputElement.checked;

    $("[data-for='filterCategoryContainer']").attr("data-value", $("#filterCategoryContainer input:checked").length);
    $("#filterCategoryArray").val($("#filterCategoryContainer input:checked").map(function() {
        return $(this).parent().text().trim();
    }).get().join(","));
    storyListProcess();
});

$("body").on("click", "#storygameListFilters #filterTagAny", function() {
    storyListProcess();
});
$("body").on("click", "#storygameListFilters #filterTagAll", function() {
    storyListProcess();
});

$("body").on("click", ".tag:not(.featured)", function() {
    const inputElement = $("#filterTagContainer label:contains(' " + $(this).text() + "')").find("input");
    inputElement.prop("checked", !inputElement.prop("checked"));
    $("[data-for='filterTagContainer']").attr("data-value", $("#filterTagContainer input:checked").length);
    $("#filterTagArray").val($("#filterTagContainer input:checked").map(function() {
        return $(this).parent().text().trim();
    }).get().join(","));
    storyListProcess();
});

$("body").on("click", ".tag.featured", function() {
    const featuredElement = $("#filterFeatureFeatured");

    if (featuredElement.prop("checked")) {
      $("#filterFeatureAll").prop("checked", true);
    } else {
      $("#filterFeatureFeatured").prop("checked", true);
    }

    storyListProcess();
});

$(".main-content").empty().append($("<h1></h1>").html("<a href='./'>Storygames</a> » Search"));

var getList = $.get(
        href("/story-listings"),
        data => {
            if (data) {
                storyListData = data;
                storyListData.forEach(e => {
                    if (storyListCategories.indexOf(e.category) === -1) {
                        storyListCategories.push(e.category);
                    }

                    e.tags.forEach(t => {
                        if (storyListTags.indexOf(t) === -1) { storyListTags.push(t); }
                    });
                });
            }
        },
        "json"
    );

$.when(getList).done(() => {
    const categorylist = storyListCategories.sort().map(e => {
        const checkboxValues = {
            type: "checkbox",
            name: "category",
            value: e
        };

        if (urlParamsParsed.categories.includes(e.toLowerCase())) {
            checkboxValues.checked = true;
        }

        return $("<label></label>").append(
            $("<input>", checkboxValues),
            " ",
            e
        )[0];
    });

    const taglist = storyListTags.sort().map(e => {
        const tagValues = {
            type: "checkbox",
            name: "tag",
            value: e
        }

        if (urlParamsParsed.tags.includes(e.toLowerCase())) {
            tagValues.checked = true;
        }

        return $("<label></label>").append(
            $("<input>", tagValues),
            " ",
            e
        )[0];
    });

    $("#filterCategoryContainer").append(categorylist);
    $("#filterTagContainer").append(taglist);

    $("[data-for='filterCategoryContainer']").attr("data-value", $("#filterCategoryContainer input:checked").length);
    $("[data-for='filterTagContainer']").attr("data-value", $("#filterTagContainer input:checked").length);

    storyListProcess();
    $(".loading").removeClass("loading");
});
</script>
<div id="storygameListContainer">
  <form id="storygameListFilters" action="#">
    <div class="flex">
      <h2 data-for="filterFeaturedContainer">Featured</h2>
      <div id="filterFeaturedContainer">
        <label><input type="radio" name="featured" id="filterFeatureAll" checked> No preference</label>
        <label><input type="radio" name="featured" id="filterFeatureFeatured"> Featured only</label>
        <label><input type="radio" name="featured" id="filterFeatureUnfeatured"> Unfeatured only</label>
      </div>
    </div>
    <div class="flex">
      <h2 data-for="filterRatingContainer">Rating</h2>
      <div id="filterRatingContainer">
        <div id="filterRatedContainer">
          <label><input type="radio" name="rated" id="filterRatedAll" checked> No preference</label>
          <label><input type="radio" name="rated" id="filterRatedRated"> Rated by me</label>
          <label><input type="radio" name="rated" id="filterRatedUnrated"> Not rated by me</label>
        </div>
        <select id="filterRatingMin">
          <option value="1">1</option>
          <option value="2">2</option>
          <option value="3" selected>3</option>
          <option value="4">4</option>
          <option value="5">5</option>
          <option value="6">6</option>
          <option value="7">7</option>
          <option value="8">8</option>
        </select>
        -
        <select id="filterRatingMax">
          <option value="1">1</option>
          <option value="2">2</option>
          <option value="3">3</option>
          <option value="4">4</option>
          <option value="5">5</option>
          <option value="6">6</option>
          <option value="7">7</option>
          <option value="8" selected>8</option>
      </select>
      </div>
    </div>
    <div class="flex">
      <h2 data-for="filterLengthContainer">Length</h2>
      <div id="filterLengthContainer">
        <select id="filterLengthMin">
          <option value="1" selected>1</option>
          <option value="2">2</option>
          <option value="3">3</option>
          <option value="4">4</option>
          <option value="5">5</option>
          <option value="6">6</option>
          <option value="7">7</option>
          <option value="8">8</option>
        </select>
        -
        <select id="filterLengthMax">
          <option value="1">1</option>
          <option value="2">2</option>
          <option value="3">3</option>
          <option value="4">4</option>
          <option value="5">5</option>
          <option value="6">6</option>
          <option value="7">7</option>
          <option value="8" selected>8</option>
      </select>
      </div>
    </div>
    <div class="flex">
      <h2 data-for="filterMaturityContainer">Maturity</h2>
      <div id="filterMaturityContainer">
        <select id="filterMaturityMin">
          <option value="1" selected>1</option>
          <option value="2">2</option>
          <option value="3">3</option>
          <option value="4">4</option>
          <option value="5">5</option>
          <option value="6">6</option>
          <option value="7">7</option>
          <option value="8">8</option>
        </select>
        -
        <select id="filterMaturityMax">
          <option value="1">1</option>
          <option value="2">2</option>
          <option value="3">3</option>
          <option value="4">4</option>
          <option value="5">5</option>
          <option value="6">6</option>
          <option value="7">7</option>
          <option value="8" selected>8</option>
        </select>
      </div>
    </div>
    <div class="flex">
      <h2 data-for="filterDateContainer">Publish date</h2>
      <div id="filterDateContainer">
        <input id="filterDateMin" type="date">
        from
        <input id="filterDateMax" type="date">
        to
      </div>
    </div>
    <div class="flex">
      <h2 data-for="filterCategoryContainer" data-value="0">Categories</h2>
      <div id="filterCategoryContainer">
        <input type="hidden" name="categories" id="filterCategoryArray">
      </div>
    </div>
    <div class="flex">
      <h2 data-for="filterTagMatchContainer">Tags match</h2>
      <div id="filterTagMatchContainer">
        <label><input type="radio" name="tagMatch" id="filterTagAll" checked> All tags</label>
        <label><input type="radio" name="tagMatch" id="filterTagAny"> Any tag</label>
      </div>
    </div>
    <div class="flex">
      <h2 data-for="filterTagContainer" data-value="0">Tags</h2>
      <div id="filterTagContainer">
        <input type="hidden" name="tags" id="filterTagArray">
      </div>
    </div>
  </form>
  <div id="storygameListPages">
    <form id="storygameListPagination" class="storygameListPagination">
      <div class="flex">
        <h3>Search</h3><br/>
        <input id="paginationSearch" type="text" autofocus>
      </div>
      <div class="flex">
        <h3>Sort by</h3><br/>
        <select id="paginationSort">
        <option value="rating-desc" selected>Highest Rating</option>
        <option value="rating-asc">Lowest Rating</option>
        <option value="published-desc">Newest</option>
        <option value="published-asc">Oldest</option>
        <option value="length-asc">Shortest</option>
        <option value="length-desc">Longest</option>
        <option value="alpha-asc">A-Z</option>
        <option value="alpha-desc">Z-A</option>
        <option value="ratings-desc">Most Ratings</option>
        <option value="ratings-asc">Fewest Ratings</option>
      </select>
      </div>
      <div id="paginationSort">
        <h3>Display</h3><br/>
        <select id="paginationPageSize">
          <option value="10">10</option>
          <option value="20" selected="selected">20</option>
          <option value="30">30</option>
          <option value="40">40</option>
        </select>
      </div>
      <div class="paginationNumeration">
        <h3>Page</h3><br/>
        <input type="button" class="paginationPrev" value="◄"><strong class="paginationPageNumber"><span class="paginationNumerator">1</span>/<span class="paginationDenominator">1</span></strong>
        <input type="button" class="paginationNext" value="►">
      </div>
    </form>
    <div id="storygameList"></div>
    <form id="storygameListSubPagination" class="storygameListPagination" style="display: none;">
      <div class="paginationNumeration">
        <h3>Page</h3>
        <input type="button" class="paginationPrev" value="◄"><strong class="paginationPageNumber"><span class="paginationNumerator">1</span>/<span class="paginationDenominator">1</span></strong>
        <input type="button" class="paginationNext" value="►">
      </div>
    </form>
  </div>
</div>

<% Server.Execute(Application("SiteRoot") & "Includes/footer.asp") %>