<%@ Control Language="C#" ClassName="MyPrivateMessageSummaryWebPart" %>
<%@ Implements Interface="System.Web.UI.WebControls.WebParts.IWebPart" %>
<%@ Import Namespace="System.Data" %>
<%@ Import Namespace="System.Data.SqlClient" %>
<%@ Import Namespace="ChooseYourStory.Web.Controls" %>
<%@ Register Assembly="ChooseYourStory" Namespace="ChooseYourStory.Web.Controls" TagPrefix="cys" %>
<script runat="server">
	protected override void OnLoad(EventArgs e)
	{
		if (!Page.User.Identity.IsAuthenticated) throw new UnauthorizedAccessException();
		
		using (SqlCommand cmd = new SqlCommand())
		{
			cmd.Connection = new SqlConnection(ConfigurationManager.ConnectionStrings["ChooseYourStory"].ConnectionString);
			cmd.CommandText = "User_MyStuff_GetPrivateMessagesSummary";
			cmd.CommandType = CommandType.StoredProcedure;
			cmd.Parameters.Add("@Username", SqlDbType.VarChar, 30).Value = Page.User.Identity.Name;
			
			SqlDataReader dr = null;
			try
			{
				cmd.Connection.Open();
				dr = cmd.ExecuteReader();
				if (dr.HasRows)
				{
					messages.DataSource = dr;
					messages.DataBind();
				}
				else
				{
					messages.Visible = false;
					noMessages.Visible = true;
				}
			}
			finally
			{
				if (dr!=null) dr.Close();
				cmd.Connection.Close();
			}
		}
		base.OnLoad(e);
	}

	bool messagesBound = false;
	void messages_ItemDataBound(object sender, EventArgs e) { messagesBound = true; }
</script>
<script runat="server" id="IWebPart">
  
	private string m_Title = "Unread PM Summary";
	public string Title { get { return m_Title; } set { m_Title = value; } }

	public string Description
  {
		get { return "Shows top 10 most unread messages."; }
    set { throw new NotImplementedException(); }
  }

  public string Subtitle { get { return string.Empty; }}
  public string TitleIconImageUrl { get { return string.Empty;} set {} }
	public string TitleUrl { get { return string.Empty; } set { } }
	public string CatalogIconImageUrl { get { return string.Empty; } set { } }	
</script>
<asp:Repeater runat="server" ID="messages" OnItemDataBound="messages_ItemDataBound">
	<HeaderTemplate>
		<table cellpadding="3" cellspacing="0" border="0">
			<tr>
				<th align="left">From</td>
				<th align="left" class="dark1border">Subject</th>
			</tr>
	</HeaderTemplate>
	<ItemTemplate>
			<tr>
				<td style="border-width:0px; border-top-width:1px; border-style:solid;" class="dark1border smallerText"><%#Eval("Sender_Username")%></td>
				<td style="border-width:0px; border-top-width:1px; border-style:solid;" class="dark1border smallerText">
					<a href="messages/message.aspx?MessageId=<%#Eval("Message_Id")%>&Target=/my/default.aspx"><%#Eval("Subject_Text")%></a>
				</td>
			</tr>
	</ItemTemplate>
	<FooterTemplate>
		</table>
	</FooterTemplate>
</asp:Repeater>
<p runat="server" id="noMessages" visible="false">You have no unread messages.</p>

